]> de.git.xonotic.org Git - xonotic/xonotic-data.pk3dir.git/blobdiff - .gitlab-ci.yml
Update gameplay hash
[xonotic/xonotic-data.pk3dir.git] / .gitlab-ci.yml
index 1eb84dbe87c84c09730077b247ad28d409a56795..87bb7bb07c412caf7368bec7950418fa7f2eb4b2 100644 (file)
@@ -7,9 +7,19 @@ workflow:
 before_script:\r
   - ln -s $PWD data/xonotic-data.pk3dir\r
 \r
+  - export MAKEFLAGS=-j$(nproc); echo MAKEFLAGS=$MAKEFLAGS\r
+#   FIXME: -march=native -mtune=native _changes the hash_, why?!?\r
+# - export CC="gcc -pipe -march=native -mtune=native"\r
+  - export CC="gcc -pipe"\r
+\r
   - git clone --depth=1 --branch=main https://gitlab.com/xonotic/gmqcc.git gmqcc\r
-  - cd gmqcc && make -j $(nproc) && export QCC="$PWD/gmqcc"\r
-  - cd ..\r
+  - make -C gmqcc || exit 1\r
+  - export QCC="$PWD/gmqcc/gmqcc"\r
+\r
+  # Makefile: don't complain about lack of tags (fetching them is slow)\r
+  - export QCCFLAGS_WATERMARK=gitlab_pipeline\r
+  # Makefile: don't compress anything or complain about lack of zip program\r
+  - export ZIP=/bin/true\r
 \r
 test_compilation_units:\r
   rules:\r
@@ -17,23 +27,36 @@ test_compilation_units:
       - qcsrc/**/*\r
   stage: test\r
   script:\r
-    - ./qcsrc/tools/compilationunits.sh\r
+    - make test\r
 \r
 test_sv_game:\r
   stage: test\r
   script:\r
     - git clone --depth=1 --branch=div0-stable https://gitlab.com/xonotic/darkplaces.git darkplaces\r
-    - cd darkplaces && make sv-debug -j $(nproc) && export ENGINE="$PWD/darkplaces-dedicated -xonotic"\r
-    - cd ..\r
+    - make -C darkplaces sv-release || exit 1\r
+    - export ENGINE="$PWD/darkplaces/darkplaces-dedicated -xonotic -noconfig -nohome"\r
+    - make qc || exit 1\r
 \r
     - mkdir -p data/maps\r
+    - wget -O data/maps/gitlab-ci.bsp https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/_init/_init.bsp\r
+\r
+    - while read LINE; do\r
+        echo $LINE;\r
+        [ "$LINE" = "All tests OK" ] && PASS=1;\r
+      done < <(${ENGINE} +developer 1 +map gitlab-ci +sv_cmd runtest +wait +quit)\r
+    - test "$PASS" = "1" || { echo 'sv_cmd runtest failed!'; exit 1; }\r
+\r
+    - ${ENGINE} +map gitlab-ci +sv_cmd dumpnotifs +wait +quit\r
+    - diff notifications.cfg data/data/notifications_dump.cfg ||\r
+        { echo 'Please update notifications.cfg using `dumpnotifs`!'; exit 1; }\r
+\r
     - wget -O data/stormkeep.pk3 http://beta.xonotic.org/autobuild-bsp/latest/stormkeep.pk3\r
     - wget -O data/maps/stormkeep.mapinfo https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.mapinfo\r
     - wget -O data/maps/stormkeep.waypoints https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints\r
     - wget -O data/maps/stormkeep.waypoints.cache https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints.cache\r
-    - make\r
-    - EXPECT=dfb2a117b18258dfcc0b95e7e9f54189\r
-    - HASH=$(${ENGINE} -noconfig -nohome +timestamps 1 +exec serverbench.cfg\r
+\r
+    - EXPECT=458e9e611a757c745da05c85a37e576d\r
+    - HASH=$(${ENGINE} +timestamps 1 +exec serverbench.cfg\r
       | tee /dev/stderr\r
       | sed -e 's,^\[[^]]*\] ,,'\r
       | grep '^:'\r
@@ -45,46 +68,32 @@ test_sv_game:
     - test "$HASH" == "$EXPECT"\r
     - exit $?\r
 \r
-test_sv_unit:\r
-  stage: test\r
-  script:\r
-    - git clone --depth=1 --branch=div0-stable https://gitlab.com/xonotic/darkplaces.git darkplaces\r
-    - cd darkplaces && make sv-debug -j $(nproc) && export ENGINE="$PWD/darkplaces-dedicated -xonotic"\r
-    - cd ..\r
-\r
-    - mkdir maps && wget -O maps/gitlab-ci.bsp https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/_init/_init.bsp\r
-    - make\r
-    - while read line; do\r
-        echo $line;\r
-        if [[ $line == "All tests OK" ]]; then exit 0; fi;\r
-      done < <(${ENGINE} +developer 1 +map gitlab-ci +sv_cmd runtest +exit)\r
-    - exit 1\r
 \r
 # NOTE: The generated docs are incomplete - they don't contain code behind SVQC CSQC MENUQC GAMEQC ifdefs.\r
 # With them added to PREDEFINED, it would take over half an hour to generate the docs and even then\r
 # they might not be complete. Doxygen doesn't handle #elif and might not understand some QC definitions.\r
-doxygen:  # rename to 'pages' when gitlab.com allows pages to exceed 100MiB\r
-  before_script:\r
-    - ln -s $PWD data/xonotic-data.pk3dir # is this needed?\r
-    - apt-get update\r
-    - apt-get -y install doxygen graphviz\r
-  stage: deploy\r
-  script:\r
-    - cd qcsrc && doxygen\r
-    - mv html ../public\r
-    - mkdir -p ~/.ssh\r
-    - for i in {0..0}; do eval $(printf "echo \$id_rsa_%02d\n" $i) >> ~/.ssh/id_rsa_base64; done\r
-    - base64 --decode ~/.ssh/id_rsa_base64 > ~/.ssh/id_rsa\r
-    - chmod 600 ~/.ssh/id_rsa\r
-    - echo -e "Host *\n\tStrictHostKeyChecking no\n\tLogLevel ERROR\n" >> ~/.ssh/config\r
-    - git config --global user.name "Gitlab CI"\r
-    - git config --global user.email "<>"\r
-    - git clone --single-branch --depth 1 ${DEPLOY_HOST}:${DEPLOY_REPO} ~/deploy_\r
-    - mkdir ~/deploy && mv ~/deploy_/.git ~/deploy && rm -r ~/deploy_\r
-    - cp -r ../public/* ~/deploy\r
-    - cd ~/deploy && git add -A . && git commit -m "Deploy ${CI_BUILD_REF}" && git push origin gh-pages\r
-  artifacts:\r
-    paths:\r
-      - public\r
-  only:\r
-    - master\r
+#doxygen:  # rename to 'pages' when gitlab.com allows pages to exceed 100MiB\r
+#  before_script:\r
+#    - ln -s $PWD data/xonotic-data.pk3dir # is this needed?\r
+#    - apt-get update\r
+#    - apt-get -y install doxygen graphviz\r
+#  stage: deploy\r
+#  script:\r
+#    - cd qcsrc && doxygen\r
+#    - mv html ../public\r
+#    - mkdir -p ~/.ssh\r
+#    - for i in {0..0}; do eval $(printf "echo \$id_rsa_%02d\n" $i) >> ~/.ssh/id_rsa_base64; done\r
+#    - base64 --decode ~/.ssh/id_rsa_base64 > ~/.ssh/id_rsa\r
+#    - chmod 600 ~/.ssh/id_rsa\r
+#    - echo -e "Host *\n\tStrictHostKeyChecking no\n\tLogLevel ERROR\n" >> ~/.ssh/config\r
+#    - git config --global user.name "Gitlab CI"\r
+#    - git config --global user.email "<>"\r
+#    - git clone --single-branch --depth 1 ${DEPLOY_HOST}:${DEPLOY_REPO} ~/deploy_\r
+#    - mkdir ~/deploy && mv ~/deploy_/.git ~/deploy && rm -r ~/deploy_\r
+#    - cp -r ../public/* ~/deploy\r
+#    - cd ~/deploy && git add -A . && git commit -m "Deploy ${CI_BUILD_REF}" && git push origin gh-pages\r
+#  artifacts:\r
+#    paths:\r
+#      - public\r
+#  only:\r
+#    - master\r